# coding: utf-8
# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class ConfusionMatrixDetails(object):
    """
    confusion matrix details
    """

    def __init__(self, **kwargs):
        """
        Initializes a new ConfusionMatrixDetails object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param matrix:
            The value to assign to the matrix property of this ConfusionMatrixDetails.
        :type matrix: dict(str, float)

        """
        self.swagger_types = {
            'matrix': 'dict(str, float)'
        }

        self.attribute_map = {
            'matrix': 'matrix'
        }

        self._matrix = None

    @property
    def matrix(self):
        """
        Gets the matrix of this ConfusionMatrixDetails.
        confusion matrix data


        :return: The matrix of this ConfusionMatrixDetails.
        :rtype: dict(str, float)
        """
        return self._matrix

    @matrix.setter
    def matrix(self, matrix):
        """
        Sets the matrix of this ConfusionMatrixDetails.
        confusion matrix data


        :param matrix: The matrix of this ConfusionMatrixDetails.
        :type: dict(str, float)
        """
        self._matrix = matrix

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
